#######    ########    #######    ########    #######    #######    #######
#      / / / /    License    \ \ \ \     
#   Copyright © 2017-2022 Eugene Istomin
#   Copyright © 2017-2022 Memex.Team
#   Designed using Psygital®, Archestry®, Valuers.Stream®, Transfer.Games®
#   and others Memex.Team concepts & products.    
#   This code is covered by a Memex.Team Licensing policy (License.md)
#######    ########    #######    ########    #######    #######    #######

image: docker:18.09.6

services:
  - name: docker:18.09.6-dind
    entrypoint:
    - /bin/sh
    command:
    - -c
    - update-ca-certificates && dockerd-entrypoint.sh

stages:
  - build
  - deploy
  


variables:
  CI_REGISTRY: registry.do.{{DOMAIN_NAME}}
  GIT_SUBMODULE_STRATEGY: recursive
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://localhost:2375 # required since we use dind
  CONTAINER_IMAGE: "${CI_REGISTRY}/${CI_PROJECT_PATH}"  
  CONTAINER_TAG: "${CI_COMMIT_REF_SLUG}:${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}"

build:
  stage: build
  when: always
  tags:
    - k8s-testlab
  only:
    - dev
    - mvp
  allow_failure: false
  before_script:
    - PROJECT='{{PROJECT_NAME}}'
    - cp /usr/local/share/ca-certificates/*.crt .
    - update-ca-certificates
    - docker login -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY}
  script:
    - docker build -t ${CONTAINER_IMAGE}/${CONTAINER_TAG} .
    - docker push ${CONTAINER_IMAGE}/${CONTAINER_TAG}
#
#
#
deploy-dev:
  stage: deploy
  when: on_success
  tags:
    - k8s-testlab
  only:
    - dev
  allow_failure: false
  image: registry.do.{{DOMAIN_NAME}}/shared/base-image:latest
  script:
    - mkdir -p /root/.kube
    - echo "${K8S_CONFIG}" | base64 -d > /root/.kube/config
    - echo "Prepare Deployment..." # TODO: Move to Helm Template in Future
    - sed -i "s/__BUILD_NUMBER__/${CONTAINER_TAG}/" _base/k8s/deployment.yml
    - sed -i "s/__NAMESPACE__/{{NAMESPACE}}/" _base/k8s/deployment.yml
    - echo "Prepare Ingress..."
    - sed -i "s/__NAMESPACE__/{{NAMESPACE}}/" _base/k8s/ingress-http.yml
    - sed -i "s/__SUB_DOMAIN__/{{APP_NAME}}.{{NAMESPACE}}/" _base/k8s/ingress-http.yml
    - echo "Prepare secrets..."
    - kubectl create secret docker-registry {{APP_NAME}}-deploy-token --docker-username=${DOCKER_PULL_IMAGE_USER} --docker-password=${DOCKER_PULL_IMAGE_PASSWORD} --docker-server=registry.do.{{DOMAIN_NAME}} --dry-run -oyaml | kubectl apply -f - -n {{NAMESPACE}}
    - kubectl apply -f _base/k8s/deployment.yml -f _base/k8s/ingress-http.yml -n {{NAMESPACE}}
#
deploy-prod:
  stage: deploy
  when: on_success
  tags:
    - k8s-testlab
  only:
    - mvp
  allow_failure: false
  image: registry.do.{{DOMAIN_NAME}}/shared/base-image:latest
  script:
    - mkdir -p /root/.kube
    - echo "${K8S_CONFIG_PROD}" | base64 -d > /root/.kube/config
    - echo "Prepare Deployment..." # TODO: Move to Helm Template in Future
    - sed -i "s/__BUILD_NUMBER__/${CONTAINER_TAG}/" _base/k8s/deployment.yml
    - sed -i "s/__NAMESPACE__/{{NAMESPACE}}/" _base/k8s/deployment.yml
    - echo "Prepare Ingress..."
    - sed -i "s/__NAMESPACE__/{{NAMESPACE}}/" _base/k8s/ingress-https.yml
    - sed -i "s/__SUB_DOMAIN__/{{APP_NAME}}.catman/" _base/k8s/ingress-https.yml
    - sed -i "s/__SSL_CERT__/catman-prod-sert/" _base/k8s/ingress-https.yml
    - echo "Prepare secrets..."
    - kubectl create secret docker-registry {{APP_NAME}}-deploy-token --docker-username=${DOCKER_PULL_IMAGE_USER} --docker-password=${DOCKER_PULL_IMAGE_PASSWORD} --docker-server=registry.do.{{DOMAIN_NAME}} --dry-run -oyaml | kubectl apply -f - -n {{NAMESPACE}}
    - kubectl apply -f _base/k8s/deployment.yml -f _base/k8s/ingress-https.yml -n {{NAMESPACE}}
